import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*; // Random

public class JeuDeTouches
   extends JFrame implements KeyListener
{
   //
   //
   //
   private static final String
      TITRE_DFAUT            = "tes-vous assez rapide?",
      TEXTE_CAR_COURANT       = "Caractre courant: ",
      TEXTE_VOTRE_CHOIX       = "Vous avez press: ",
      TEXTE_TAT_INITIAL      = "Bienvenue au Jeu De Touches. Pressez n'importe quelle touche pour dmarrer...",
      TEXTE_TAT_COURANT      = "Essayez de presser la touche correspondant au caractre qui vous est propos. Bonne chance!",
      TEXTE_TAT_VICTOIRE     = "VOUS AVEZ GAGN!!!!!",
      TEXTE_TAT_DFAITE      = "Dsol, vous avez perdu.";

   //
   //
   //
   private static final int
      TAT_INITIAL         = 0,
      TAT_EN_COURS        = 1,
      TAT_PARTIE_TERMINE = 2;

   //
   //
   //
   public static class GnrateurLettres
   {
      private Random m_Gnrateur;
      private static GnrateurLettres LeGnrateur = new GnrateurLettres ();
      private char ProchaineLettre ()
      {
         final int BORNE_MAX = '9' - '0' + 1;
         return (char) (m_Gnrateur.nextInt (BORNE_MAX) + '0');
      }
      private GnrateurLettres ()
      {
         m_Gnrateur = new Random ();
      }
      public static GnrateurLettres GetGnrateur ()
      {
         return LeGnrateur;
      }
      protected Object clone () { return null; }
   }

   //
   //
   //
   private char m_LettreCourante;
   private void SetLettreCourante(final char c)
   {
      m_LettreCourante = c;
   }
   private char GetLettreCourante()
   {
      return m_LettreCourante;
   }

   //
   //
   //
   private JLabel m_lblLettreCourante,
                  m_lblVotreChoix,
                  m_lbltat;
   private int m_tat;
   private int Gettat ()
   {
      return m_tat;
   }
   private void Settat (final int tat)
   {
      m_tat = tat;
   }
   //
   //
   //
   private class Afficheur
      extends Thread
   {
      private boolean m_Arrt;
      private void SetArrt (final boolean Arrt)
      {
         m_Arrt = Arrt;
      }
      public boolean GetArrt ()
      {
         return m_Arrt;
      }
      //
      //
      //
      public Afficheur ()
      {
         super ();
         SetArrt (false);
      }
      //
      //
      //
      public void run ()
      {
         while (Gettat () != TAT_PARTIE_TERMINE)
         {
            SetLettreCourante (GnrateurLettres.GetGnrateur ().ProchaineLettre ());
            m_lblLettreCourante.setText (TEXTE_CAR_COURANT + GetLettreCourante ());
            try
            {
               sleep (250); // un quart de seconde
            }
            catch (InterruptedException ie) { }
         }
         SetArrt (true);
      }
   }

   //
   //
   //
   private Afficheur m_Afficheur;

   //
   //
   //
   public JeuDeTouches ()
   {
      super (TITRE_DFAUT);
      Settat (TAT_INITIAL);
      init ();
      m_Afficheur = null;
   }
   //
   //
   //
   public void init ()
   {
      final int LARGEUR_PANNEAU_HAUT = 2,
                HAUTEUR_PANNEAU_HAUT = 1;
      JPanel PanneauHaut = new JPanel ();

      PanneauHaut.setLayout (new GridLayout (HAUTEUR_PANNEAU_HAUT, LARGEUR_PANNEAU_HAUT));
      m_lblLettreCourante = new JLabel (TEXTE_CAR_COURANT, JLabel.LEFT);
      m_lblVotreChoix     = new JLabel (TEXTE_VOTRE_CHOIX,   JLabel.RIGHT);
      PanneauHaut.add (m_lblLettreCourante);
      PanneauHaut.add (m_lblVotreChoix);

      m_lbltat = new JLabel (TEXTE_TAT_INITIAL, JLabel.CENTER);

      getContentPane ().add (PanneauHaut,    BorderLayout.NORTH);
      getContentPane ().add (m_lbltat, BorderLayout.SOUTH);

      addKeyListener (this);
      addWindowListener
      (
         new WindowAdapter ()
         {
            public void windowClosing (WindowEvent e)
            {
               if (m_Afficheur != null)
               {
                  Settat (TAT_PARTIE_TERMINE);
                  while (!m_Afficheur.GetArrt ())
                     Thread.yield ();
               }
               System.exit (0);
            }
         }
      );
   }
   // Keyboard event handling
   public void keyPressed (KeyEvent e)
   {
      if (Gettat () == TAT_EN_COURS)
      {
         //
         //
         //
         m_lblVotreChoix.setText (TEXTE_VOTRE_CHOIX + e.getKeyChar ());
         Settat (TAT_PARTIE_TERMINE);
         while (!m_Afficheur.GetArrt ())
            Thread.yield ();
         if (e.getKeyChar () == GetLettreCourante ())
            m_lbltat.setText (TEXTE_TAT_VICTOIRE);
         else
            m_lbltat.setText (TEXTE_TAT_DFAITE);
      }
   }
   public void keyReleased (KeyEvent e)
   {
      if (Gettat () == TAT_INITIAL)
      {
         m_lbltat.setText (TEXTE_TAT_COURANT);
         pack ();
         m_Afficheur = new Afficheur();
         m_Afficheur .start ();
         Settat (TAT_EN_COURS);
      }
   }
   public void keyTyped (KeyEvent e) { }

   public static void main (String [] args)
   {
      JeuDeTouches jdt = new JeuDeTouches();
      jdt.pack ();
      jdt.show ();
   }
}